#ifdef GL_ES
precision mediump float;
#endif

varying vec4 v_color;
varying vec2 v_texCoord0;

uniform sampler2D u_texture;

void main() {
    // Sample the texture
    vec4 texColor = texture2D(u_texture, v_texCoord0);

    // Invert the color
    vec3 invertedColor = 1.0 - texColor.rgb;

    // Set the alpha value
    float alpha = texColor.a;

    // Combine the inverted color with the original alpha
    gl_FragColor = vec4(invertedColor, alpha) * v_color;
}