#ifdef GL_ES
precision mediump float;
#endif

varying vec4 v_color;
varying vec2 v_texCoords;
uniform sampler2D u_texture;
uniform float u_time; // Time parameter for animation

void main() {
    vec2 uv = v_texCoords;

    // Wave effect
    float waveOffset = sin(uv.x * 60.0 + u_time) * 0.002; // Adjust the frequency and amplitude as needed
    uv.y += waveOffset;

    // Pulsating effect
    float pulsateAmount = 1.0;  // Adjust pulsating amount
    float pulsate = sin(u_time * pulsateAmount) * 0.15 + 1.0;  // Map sine wave to [0, 1]

    // Create a local variable to store the modified color
    vec4 modifiedColor = v_color;

    // Modify the alpha channel
    modifiedColor.a *= pulsate;

    gl_FragColor = modifiedColor * texture2D(u_texture, uv);
}