// Fragment shader
#ifdef GL_ES
precision mediump float;
#endif

varying vec4 v_color;
varying vec2 v_texCoords;

uniform float u_softness;
uniform sampler2D u_texture; // Added this line to define the texture

void main() {
    vec4 color = vec4(0.0);
    float totalAlpha = 0.0;

    // Sample neighboring pixels to create a soft border effect
    for (float dx = -1.0; dx <= 1.0; dx += 1.0) {
        for (float dy = -1.0; dy <= 1.0; dy += 1.0) {
            vec2 offset = vec2(dx, dy) * u_softness;
            color += texture2D(u_texture, v_texCoords + offset) * smoothstep(1.0, 0.0, length(offset));
            totalAlpha += smoothstep(1.0, 0.0, length(offset));
        }
    }

    // Normalize the color by the total alpha to avoid brightening
    gl_FragColor = color / totalAlpha * v_color;
}
